<template>
	<view>
		<view class="width100" v-if="couponDesInfo">
			<view class="width100 fotct coupon-status font20 fcorred" v-if="couponDesInfo.couponCodeInfo.status == 3">
				已使用
			</view>
			<view class="width100 fotct coupon-status font20 fcor41c" v-if="couponDesInfo.couponCodeInfo.status == 2">
				未使用
			</view>
			<view class="line1"></view>
			<view class="width90">
				<view class="flright fotct">
					<image mode="widthFix" class="coupon-img" :src="imageUrl+couponDesInfo.couponInfo.couponImg"></image>
				</view>
				<view class="coupon-mes mart10">
					<view class="fcor333 fontwig6 font24 width100 text2">{{couponDesInfo.couponInfo.couponName}}</view>
					<view class="fcor666  font13 width100 mart5" v-if="oneTime">
						领取时间:{{oneTime | formatDate('-')}}</view>
					<view class="fcor666  font13 width100 mart5" v-if="twoTime">
						使用有效期:{{twoTime | formatDate('-')}}</view>
					<view class="fcorred  font15 width100 mart5" v-if="threeTime">
						消费时间:{{threeTime | formatDate('-')}}</view>
				</view>
			</view>

			<view class="line1 mart15"></view>
			<view class="width100 fotct" v-if="couponDesInfo.couponInfo.couponSource == 4">
				<view class="font28 fontlet mart5 marb10" style="color: #1593c3;">视频教程</view>
				<yy-video-player
				    :auto-play="false" 
				    :url="imagewxUrl+imgadres3"  
				    :poster="poster" 
				    :show-back-btn="true"
				  ></yy-video-player>
				<image :src="imagewxUrl+imgadres2" mode="widthFix" class="mart10"></image>
			</view>


			<view class="width100">
				<view class="mart20 fotct fcorred font15 marb20 height20"
					v-if="couponDesInfo.couponInfo.reserveStatus &&  couponDesInfo.highUserCoupon.status  != 0">
					预约订单已成功 门店会在24小时内联系您</view>
				<view class="mart20 fotct fcorred font15 marb20 height20"
					v-if="!couponDesInfo.couponInfo.reserveStatus && couponDesInfo.highUserCoupon.status != 0 && couponDesInfo.couponInfo.couponSource == 3">
					请出示核销码(商户扫客户)</view>
				<view class="mart20 fotct fcorred font15 marb20 height20"
					v-if="!couponDesInfo.couponInfo.reserveStatus && couponDesInfo.highUserCoupon.status != 0 && couponDesInfo.couponInfo.couponSource != 3">
					请告知加油员用码商支付</view>
				<view class="width90 mart20 fotct" v-if="!couponDesInfo.couponInfo.reserveStatus">
					<image class="coupon-qr" :src="imageUrl+'couponCode/'+couponDesInfo.highUserCoupon.qrCodeImg">
					</image>
				</view>
			</view>
			<view class="width90 mart30 font20 fcor333 fotct marb40" v-if="!couponDesInfo">二维码生效中,前往个人中心查看</view>
			<view class="width90 height45l font18 fcor666 aliitem" v-if="storeList">
				<view class="width50 alijusstart">
					<image mode="widthFix" style="width: 50rpx; max-height: 50rpx;margin-right: 10px;"
						src="../../../static/img/adresw.png"></image> 门店信息
				</view>
				<view class="width50 alijusend font15" @click="jumpstorelist">查看更多<image style="width: 18px; height: 17px;"
						src="../../../static/img/jt.png">
						</images>
				</view>
			</view>
			<view class="width90 mart20" style="height: 80px;" v-for="(store,i) in storeList" :key="i">
				<view class="coupon-des flleft">
					<image mode="widthFix" :src="imageUrl+store.ext1"></image>
				</view>
				<view class="coupon-cont-dh">
					<view class="coupon-title flleft width70">
						<view class="font20 fcor333 fontwig6 width100 text1">{{store.storeName}}</view>
						<view class="font14 fcor999 width100 text2 mart5">{{store.address}}</view>
					</view>
					<view class="coupon-map flright width30 fotct" @click="seeloaction(store)">
						<!-- 地图logo -->
						<image :src="imagewxUrl+imgadres1">
						</image>
						<view class="mart5 fcor999 font13">{{store.distance}}km</view>
					</view>
				</view>
			</view>
		</view>
		<wybPopup ref="popup" class="fotct" type="center" height="850" width="600" radius="6" bgColor="" :showCloseIcon="true" >
			<image class="popImg" mode="widthFix" :src="imagewxUrl+imgadres4" @click="jumpcjhuod"></image>
		</wybPopup>
		<view class="height60"></view>
		<button class="coupne-btn width100" @click="toUser">个人中心</button>
		
	</view>
</template>

<script>
	import {
		getUserNewCouponDetail,
		getStoreListByCoupon,
		getActivityByCoupon
	} from "../../../Utils/Api.js";
	import xiaoVideoElement from '../../../components/yy-video-player/yy-video-player.nvue';
	import wybPopup from '../../../components/wyb-popup/wyb-popup.vue';
	let app = getApp()
	export default {
		components: {
			xiaoVideoElement,
			wybPopup
		},
		data() {
			return {
				couDesId: '',
				imageUrl: app.globalData.imgUrl,
				imagewxUrl: app.globalData.imageWxImg,
				imgadres2: 'video.jpg',
				imgadres3: 'playVideo.mp4',
				imgadres4: 'activityimg.png',
				imgadres1: 'dhl.png',
				couponDesInfo: [],
				storeList: [],
				oneTime: '',
				twoTime: '',
				threeTime: '',
				pageNum: 1,
				pageSize: 1,
				isNoMoreData: false
			}
		},
		onLoad(option) {
			this.couDesId = option.id;
			this.getUserNewCouponDetail();
			this.getActivityByCoupon();
		},
		filters: {
			//过滤器 用于格式化时间
			formatDate: function(value, spe = '/') {
				let data = new Date(value);
				let year = data.getFullYear();
				let month = data.getMonth() + 1;
				let day = data.getDate();
				let h = data.getHours();
				let mm = data.getMinutes();
				let s = data.getSeconds();
				month = month >= 10 ? month : "0" + month;
				day = day >= 10 ? day : "0" + day;
				h = h >= 10 ? h : "0" + h;
				mm = mm >= 10 ? mm : "0" + mm;
				s = s >= 10 ? s : "0" + s;
				return `${year}${spe}${month}${spe}${day} ${h}:${mm}:${s}`;
			}
		},
		onReachBottom() {
			this.getStoreListByCoupon();
		},
		methods: {
			//我的卡券详情
			getUserNewCouponDetail() {
				uni.showLoading({
					title: '加载中...'
				})
				let params = {
					couponId: this.couDesId
				}
				getUserNewCouponDetail(params).then(res => {
					if (res.return_code == '000000') {
						uni.hideLoading();
						this.couponDesInfo = res.return_data;
						if(res.return_data.couponInfo.couponSource == 4){
							this.oneTime = res.return_data.highUserCoupon.createTime;
							this.twoTime = res.return_data.highUserCoupon.useEndTime;
							this.threeTime = res.return_data.highUserCoupon.consumeTime;
							return;
						}
						this.getStoreListByCoupon();
						this.oneTime = res.return_data.couponCodeInfo.receiveTime;
						this.twoTime = res.return_data.couponCodeInfo.salesEndTime;
						this.threeTime = res.return_data.couponCodeInfo.consumeTime;
					} else {
						uni.hideLoading()
					}
				})
			},
			//显示弹出
			showPopup() {
				this.$refs.popup.show();
			},
			//关闭弹窗
			closePopup() {
				this.$refs.popup.hide();
			},
			// 获取奖品列表
			getActivityByCoupon() {
				let params = {
					couponId: this.couDesId
				}
				getActivityByCoupon(params).then(res => {
					if (res.return_code == '000000' && res.return_data) {
						this.showPopup();
					}
				});
			},
			//跳转抽奖活动
			jumpcjhuod(){
				this.closePopup();
				uni.reLaunch({
					url:'../../../subPages/lottery/lottery?id='+this.couDesId
				})
			},
			//跳转门店
			jumpstorelist() {
				uni.navigateTo({
					url: '../../../subPages/sotre-details-list/sotre-details-list?id=' + this.couDesId
				})
			},
			//导航
			seeloaction(e) {
				uni.openLocation({
					latitude: Number(e.latitude), //目的地的定位
					longitude: Number(e.longitude), //目的地的定位
					name: e.storeName,
					address: e.address
				})
			},

			/**
			 * 查询门店列表
			 */
			getStoreListByCoupon() {
				uni.showLoading({
					title: '加载中...'
				})
				if (this.isNoMoreData) {
					uni.hideLoading()
					return false;
				}
				let pagenum = this.pageNum;
				let params = {
					couponId: this.couDesId,
					longitude: app.globalData.longitude,
					latitude: app.globalData.latitude,
					pageNum: pagenum,
					pageSize: this.pageSize
				}
				getStoreListByCoupon(params).then(res => {
					if (res.return_code == '000000' && res.return_data.list != '') {
						uni.hideLoading();
						this.isNoMoreData = res.return_data.list.length == this.pageSize ? false : true;
						this.storeList = this.storeList.concat(res.return_data.list);
						if (res.return_data.total == (this.pageNum * this.pageSize)) {
							this.isNoMoreData = true;
						}
						this.pageNum = res.return_data.list.length == this.pageSize ? ++pagenum : pagenum;
					} else {
						this.storeList = [];
						uni.hideLoading()
					}
				})
			},
			toUser() {
				// uni.switchTab({
				// 	url: '/pages/tabBar/user/user'
				// });
				uni.reLaunch({
					url: '/pages/tabBar/user/user'
				})
			},
			scan() {
				uni.scanCode({
					success: function(res) {
						console.log('条码类型：' + res.scanType);
						console.log('条码内容：' + res.result);
					}
				});
			}
		}
	}
</script>
<style lang="scss">
	.popImg {
		width: 300px;
		height: 440px;
	}
	
	.loading-text {
		width: 100%;
		display: flex;
		justify-content: center;
		align-items: center;
		height: 60upx;
		color: #979797;
		font-size: 24upx;
	}

	.coupon-status {
		height: 35px;
		line-height: 35px;
	}

	.coupon-mes {
		margin-right: 90px;
	}

	.coupon-img {
		width: 80px;
		max-height: 80px;
	}

	.coupon-qr {
		width: 250px;
		height: 250px;
	}

	.coupon-des {
		width: 80px;
		max-height: 80px;
		text-align: center;
		color: white;
		font-size: 28px;
		border-radius: 10px;
		image{
			width: 80px;
			max-height: 80px;
		}
	}

	.coupon-cont-dh {
		margin-left: 90px;
	}

	.coupon-map image {
		width: 25px;
		height: 25px;
	}

	.coupon-no {
		height: 80px;
		line-height: 80px;
		border: 1px solid #b2b2b2;
		border-radius: 10px;
	}

	.coupne-btn {
		position: fixed;
		bottom: 0px;
		background-color: red;
		color: #FFFFFF;
	}

	.coupne-btn {
		position: fixed;
		bottom: 0px;
		background-color: red;
		color: #FFFFFF;
	}
</style>
